<!--version: 2, 设备选择弹窗-->

<template>
  <el-dialog :title="title" :visible="show" width="1000px" top="2vh" @open="open" @close="close"
             :append-to-body="true">
    <el-form size="small" :inline="true" label-width="5em" @submit.prevent.native="onSearch">
      <el-form-item label="应用名称" prop="name">
        <el-input
          v-model="searchForm.name"
          placeholder="请输入应用名称"
          clearable
          @keyup.enter.native="onSearch"
        />
      </el-form-item>
      <el-form-item label="应用类型" prop="type">
        <el-select v-model="searchForm.type" placeholder="请选择应用类型" style="width: 100%" @change="onSearch"> 
          <el-option v-for="item of dict.type.app_type" :key="item.value" :label="item.label" :value="item.value"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="onSearch()" icon="el-icon-search">搜索</el-button>
      </el-form-item>
    </el-form>

    <el-row v-if="multiple" style="margin-bottom: 1em;">
      <span style="line-height: 28px">已选：</span>
      <span style="line-height: 28px" v-if="selected == null || selected.length === 0">暂无</span>
      <el-tag
        v-for="(item,index) of selected"
        type="primary"
        closable
        disable-transitions
        style="margin-right: 4px"
        @close="onCloseSelected(index)"
      >{{item.name}}</el-tag>
    </el-row>

    <el-table
      ref="multipleTable"
      :data="tableData"
      v-loading="loadTable"
      @row-click="changeSelection"
      @row-dblclick="select"
      @select-all="selectionAll"
      @select="changeSelection"
      highlight-current-row
    >
      <el-table-column type="selection" v-if="multiple"/>
      <template v-for="column of showColumns">
        <el-table-column
            :key="column.key"
            :label="column.label"
            :prop="column.key"
            :align="column.align"
            :min-width="column.minWidth"
            :sort-orders="orderSorts"
            :sortable="column.sortable"
            :show-overflow-tooltip="column.overflow"
            :width="column.width"
        >
          <template slot-scope="d">
            <template v-if="column.key === 'id'">
              {{d.row[column.key]}}
            </template>
            <template v-else-if="column.key === 'type'">
              <dict-tag :options="dict.type.app_type" :value="d.row[column.key]"/>
            </template>
            <template v-else>
              {{d.row[column.key]}}
            </template>
          </template>
        </el-table-column>
      </template>
    </el-table>
    <pagination
      :limit.sync="searchForm.pageSize"
      :page.sync="searchForm.pageNum"
      :total="total"
      @pagination="searchList">
    </pagination>
    <template #footer>
      <el-button type="primary" @click="submit()">确定</el-button>
    </template>
  </el-dialog>
</template>

<script>
import {clone} from "@/utils";
import { $showColumns } from '@/utils/mixins';
import { listApp } from '@/api/bst/app';

export default {
  name: "AppDialog",
  mixins: [$showColumns],
  dicts: ['app_type'],
  props: {
    // 标题
    title: {
      type: String,
      default: '选择应用'
    },
    value: {
      type: [String, Number, Array],
      default: null,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    show: {
      type: Boolean,
      default: false
    },
    query: {
      type: Object,
      default: () => ({})
    },
    initSelect: {
      type: Array,
      default: null,
    }
  },
  data() {
    return {
      // 字段列表
      columns: [
        {key: 'id', visible: true, label: 'ID', minWidth: null, sortable: true, overflow: false, align: 'center', width: "80"},
        {key: 'name', visible: true, label: '应用名称', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'type', visible: true, label: '应用类型', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'createTime', visible: true, label: '创建时间', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
      ],
      // 排序方式
      orderSorts: ['ascending', 'descending', null],
      loadTable: false,
      tableData: [],
      searchForm: {},
      total: 0,
      row: null,
      selected: [],
    }
  },
  methods: {
    onCloseSelected(index) {
      this.selected.splice(index, 1);
      this.$nextTick(() => {
        this.refreshTableSelection();
      })
    },
    // 获取数据列表
    searchList() {
      this.loadTable = true;
      listApp(this.searchForm).then(response => {
        this.tableData = response.rows;
        this.total = response.total;
        // 刷新表格状态
        this.$nextTick(()=>{
          this.refreshTableSelection();
        })
      }).finally(() =>{
        this.loadTable = false;
      })
    },
    // 打开时
    open() {
      this.searchForm = {
        pageNum: 1,
        pageSize: 10,
        ...this.query,
      }

      if (this.initSelect) {
        this.selected = clone(this.initSelect);
      } else {
        this.selected = [];
      }

      this.searchList();
    },
    // 刷新表格的选中状态
    refreshTableSelection() {
      if(this.multiple){
        this.tableData.forEach(item => {
          if (this.selected.map(j => j.id).includes(item.id)) {
            this.$refs.multipleTable.toggleRowSelection(item, true);
          } else {
            this.$refs.multipleTable.toggleRowSelection(item, false);
          }
        });
      }
    },
    // 全选
    selectionAll(val){
      let flag = val.length > 0;
      this.tableData.forEach(item => {
        if (flag && !this.selected.map(i => i.id).includes(item.id)){
          this.selected.push(item);
        } else if (!flag && this.selected.map(i => i.id).includes(item.id)){
          this.selected = this.selected.filter(i => i.id !== item.id);
        }
      })
    },
    // 确认选中
    submit() {
      if (this.multiple) {
        this.$emit('select', this.selected);
      } else {
        this.select(this.row);
      }
    },
    // 更换某一行的选中状态
    changeSelection(row){
      if(this.multiple){
        if (this.selected.map(i => i.id).includes(row.id)){
          this.$refs.multipleTable.toggleRowSelection(row, false);
          this.selected = this.selected.filter(i => i.id !== row.id);
        }else {
          this.$refs.multipleTable.toggleRowSelection(row, true);
          this.selected.push(row);
        }
      } else {
        this.row = row;
      }
    },
    // 点击搜索
    onSearch() {
      this.searchForm.pageNum = 1;
      this.searchList();
    },
    // 关闭弹窗
    close() {
      this.$emit('update:show', false);
      this.searchForm.pageNum = 1;
      this.searchForm.pageSize = 10;
    },
    // 选中一行
    select(row) {
      if (!this.multiple) {
        if (!row) return this.$message.error('请选择一行');
        this.selected = [row];
        this.$emit('select', row);
      }
    },
  },
}
</script>
